+
+
+
+
+
+
+
diff --git a/front-web/src/main/resources/static/user-manage.html b/front-web/src/main/resources/static/user-manage.html
new file mode 100644
index 0000000..b52f8cb
--- /dev/null
+++ b/front-web/src/main/resources/static/user-manage.html
@@ -0,0 +1,84 @@
+
+
+
+
+
+
+
+
+
+
+
+
+
Soulmates
+
+
+
+
+
+
+
+
+
+
+
+
+
사용자 관리
+
+
+
+
+
+
+ | 이름 |
+ email |
+ 생성일 |
+
+
+
+
+
+
+
+
+
+
+
+
+
diff --git a/front-web/src/test/java/com/auth/frontserver/FrontServerApplicationTests.java b/front-web/src/test/java/com/auth/frontserver/FrontServerApplicationTests.java
new file mode 100644
index 0000000..8b8757c
--- /dev/null
+++ b/front-web/src/test/java/com/auth/frontserver/FrontServerApplicationTests.java
@@ -0,0 +1,13 @@
+package com.auth.frontserver;
+
+import org.junit.jupiter.api.Test;
+import org.springframework.boot.test.context.SpringBootTest;
+
+@SpringBootTest
+class FrontServerApplicationTests {
+
+ @Test
+ void contextLoads() {
+ }
+
+}
diff --git a/gateway/.gitattributes b/gateway/.gitattributes
new file mode 100644
index 0000000..dfe0770
--- /dev/null
+++ b/gateway/.gitattributes
@@ -0,0 +1,2 @@
+# Auto detect text files and perform LF normalization
+* text=auto
diff --git a/gateway/.gitignore b/gateway/.gitignore
new file mode 100644
index 0000000..549e00a
--- /dev/null
+++ b/gateway/.gitignore
@@ -0,0 +1,33 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
diff --git a/gateway/.mvn/wrapper/MavenWrapperDownloader.java b/gateway/.mvn/wrapper/MavenWrapperDownloader.java
new file mode 100644
index 0000000..a45eb6b
--- /dev/null
+++ b/gateway/.mvn/wrapper/MavenWrapperDownloader.java
@@ -0,0 +1,118 @@
+/*
+ * Copyright 2007-present the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ * https://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+import java.net.*;
+import java.io.*;
+import java.nio.channels.*;
+import java.util.Properties;
+
+public class MavenWrapperDownloader {
+
+ private static final String WRAPPER_VERSION = "0.5.6";
+ /**
+ * Default URL to download the maven-wrapper.jar from, if no 'downloadUrl' is provided.
+ */
+ private static final String DEFAULT_DOWNLOAD_URL = "https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/"
+ + WRAPPER_VERSION + "/maven-wrapper-" + WRAPPER_VERSION + ".jar";
+
+ /**
+ * Path to the maven-wrapper.properties file, which might contain a downloadUrl property to
+ * use instead of the default one.
+ */
+ private static final String MAVEN_WRAPPER_PROPERTIES_PATH =
+ ".mvn/wrapper/maven-wrapper.properties";
+
+ /**
+ * Path where the maven-wrapper.jar will be saved to.
+ */
+ private static final String MAVEN_WRAPPER_JAR_PATH =
+ ".mvn/wrapper/maven-wrapper.jar";
+
+ /**
+ * Name of the property which should be used to override the default download url for the wrapper.
+ */
+ private static final String PROPERTY_NAME_WRAPPER_URL = "wrapperUrl";
+
+ public static void main(String args[]) {
+ System.out.println("- Downloader started");
+ File baseDirectory = new File(args[0]);
+ System.out.println("- Using base directory: " + baseDirectory.getAbsolutePath());
+
+ // If the maven-wrapper.properties exists, read it and check if it contains a custom
+ // wrapperUrl parameter.
+ File mavenWrapperPropertyFile = new File(baseDirectory, MAVEN_WRAPPER_PROPERTIES_PATH);
+ String url = DEFAULT_DOWNLOAD_URL;
+ if (mavenWrapperPropertyFile.exists()) {
+ FileInputStream mavenWrapperPropertyFileInputStream = null;
+ try {
+ mavenWrapperPropertyFileInputStream = new FileInputStream(mavenWrapperPropertyFile);
+ Properties mavenWrapperProperties = new Properties();
+ mavenWrapperProperties.load(mavenWrapperPropertyFileInputStream);
+ url = mavenWrapperProperties.getProperty(PROPERTY_NAME_WRAPPER_URL, url);
+ } catch (IOException e) {
+ System.out.println("- ERROR loading '" + MAVEN_WRAPPER_PROPERTIES_PATH + "'");
+ } finally {
+ try {
+ if (mavenWrapperPropertyFileInputStream != null) {
+ mavenWrapperPropertyFileInputStream.close();
+ }
+ } catch (IOException e) {
+ // Ignore ...
+ }
+ }
+ }
+ System.out.println("- Downloading from: " + url);
+
+ File outputFile = new File(baseDirectory.getAbsolutePath(), MAVEN_WRAPPER_JAR_PATH);
+ if (!outputFile.getParentFile().exists()) {
+ if (!outputFile.getParentFile().mkdirs()) {
+ System.out.println(
+ "- ERROR creating output directory '" + outputFile.getParentFile().getAbsolutePath() + "'");
+ }
+ }
+ System.out.println("- Downloading to: " + outputFile.getAbsolutePath());
+ try {
+ downloadFileFromURL(url, outputFile);
+ System.out.println("Done");
+ System.exit(0);
+ } catch (Throwable e) {
+ System.out.println("- Error downloading");
+ e.printStackTrace();
+ System.exit(1);
+ }
+ }
+
+ private static void downloadFileFromURL(String urlString, File destination) throws Exception {
+ if (System.getenv("MVNW_USERNAME") != null && System.getenv("MVNW_PASSWORD") != null) {
+ String username = System.getenv("MVNW_USERNAME");
+ char[] password = System.getenv("MVNW_PASSWORD").toCharArray();
+ Authenticator.setDefault(new Authenticator() {
+ @Override
+ protected PasswordAuthentication getPasswordAuthentication() {
+ return new PasswordAuthentication(username, password);
+ }
+ });
+ }
+ URL website = new URL(urlString);
+ ReadableByteChannel rbc;
+ rbc = Channels.newChannel(website.openStream());
+ FileOutputStream fos = new FileOutputStream(destination);
+ fos.getChannel().transferFrom(rbc, 0, Long.MAX_VALUE);
+ fos.close();
+ rbc.close();
+ }
+
+}
diff --git a/gateway/.mvn/wrapper/maven-wrapper.jar b/gateway/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 0000000..2cc7d4a
Binary files /dev/null and b/gateway/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/gateway/.mvn/wrapper/maven-wrapper.properties b/gateway/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 0000000..642d572
--- /dev/null
+++ b/gateway/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1,2 @@
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.6.3/apache-maven-3.6.3-bin.zip
+wrapperUrl=https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar
diff --git a/gateway/README.md b/gateway/README.md
new file mode 100644
index 0000000..de813df
--- /dev/null
+++ b/gateway/README.md
@@ -0,0 +1,124 @@
+[user-server 바로가기](https://github.com/hscom96/msa-user-server)
+[auth-server 바로가기](https://github.com/hscom96/msa-auth-server)
+[eureka-server 바로가기](https://github.com/hscom96/msa-eureka-server)
+[front-web 바로가기](https://github.com/hscom96/msa-front-web)
+
+
+
+
+
인증서버 구축 :zap:
+
+
+
+## 👨 Part
+총 1인
+- 김현수 : 프론트, 백엔드
+
+## :rocket:기능
+- 회원가입
+- 로그인
+- 이메일 인증
+- 사용자 정보 조회 (관리자권한만 가능)
+
+
+
+## :orange_book: 개발일지
+:heavy_check_mark: 회원가입 구현과정
+https://lovecode.tistory.com/122
+
+:heavy_check_mark: 로그인 구현과정
+https://lovecode.tistory.com/124
+
+
+
+## :closed_book: 기술
+
+#### :orange_book: backend
+- Springboot
+- MYSQL, JPA
+- spring cloud (zuul, eureka)
+
+#### :orange_book: frontend
+- HTML
+- CSS
+- JavaScript
+- JQuery
+
+
+
+
+## :package: 개발 환경
+- jdk 11
+- mysql 8.0.22
+
+
+
+## :closed_book: server port
+- gateway : 8090
+- auth-server : 8081
+- user-server : 8020
+- eureka-server : 8761
+- front-web : 8030
+
+
+
+## 📸 Schreenshot
+#### :heavy_check_mark: 메인 화면
+
+
+
+
+
+
+#### :heavy_check_mark: 로그인
+
+
+
+
+
+
+#### :heavy_check_mark: 회원가입
+
+
+
+
+
+
+#### :heavy_check_mark: 회원가입 성공
+
+
+
+
+
+
+#### :heavy_check_mark: 사용자 관리
+
+
+
+
+
+
+
+## :mag: 대표 기능 로직
+#### :heavy_check_mark: 로그인 흐름
+
+
+
+
+
+
+#### :heavy_check_mark: 사용자 조회 (관리자권한)
+
+
+
+
+
+
+#### :heavy_check_mark: 회원가입 흐름
+
+
+
+
+
+
+
diff --git a/gateway/mvnw b/gateway/mvnw
new file mode 100644
index 0000000..3c8a553
--- /dev/null
+++ b/gateway/mvnw
@@ -0,0 +1,322 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ]; then
+
+ if [ -f /etc/mavenrc ]; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ]; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false
+darwin=false
+mingw=false
+case "$(uname)" in
+CYGWIN*) cygwin=true ;;
+MINGW*) mingw=true ;;
+Darwin*)
+ darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="$(/usr/libexec/java_home)"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ]; then
+ if [ -r /etc/gentoo-release ]; then
+ JAVA_HOME=$(java-config --jre-home)
+ fi
+fi
+
+if [ -z "$M2_HOME" ]; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ]; do
+ ls=$(ls -ld "$PRG")
+ link=$(expr "$ls" : '.*-> \(.*\)$')
+ if expr "$link" : '/.*' >/dev/null; then
+ PRG="$link"
+ else
+ PRG="$(dirname "$PRG")/$link"
+ fi
+ done
+
+ saveddir=$(pwd)
+
+ M2_HOME=$(dirname "$PRG")/..
+
+ # make it fully qualified
+ M2_HOME=$(cd "$M2_HOME" && pwd)
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=$(cygpath --unix "$M2_HOME")
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=$(cygpath --unix "$JAVA_HOME")
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=$(cygpath --path --unix "$CLASSPATH")
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="$( (
+ cd "$M2_HOME"
+ pwd
+ ))"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="$( (
+ cd "$JAVA_HOME"
+ pwd
+ ))"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="$(which javac)"
+ if [ -n "$javaExecutable" ] && ! [ "$(expr \"$javaExecutable\" : '\([^ ]*\)')" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=$(which readlink)
+ if [ ! $(expr "$readLink" : '\([^ ]*\)') = "no" ]; then
+ if $darwin; then
+ javaHome="$(dirname \"$javaExecutable\")"
+ javaExecutable="$(cd \"$javaHome\" && pwd -P)/javac"
+ else
+ javaExecutable="$(readlink -f \"$javaExecutable\")"
+ fi
+ javaHome="$(dirname \"$javaExecutable\")"
+ javaHome=$(expr "$javaHome" : '\(.*\)/bin')
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ]; then
+ if [ -n "$JAVA_HOME" ]; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ]; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="$(which java)"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ]; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]; then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ]; do
+ if [ -d "$wdir"/.mvn ]; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=$(
+ cd "$wdir/.."
+ pwd
+ )
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' <"$1")"
+ fi
+}
+
+BASE_DIR=$(find_maven_basedir "$(pwd)")
+if [ -z "$BASE_DIR" ]; then
+ exit 1
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in wrapperUrl)
+ jarUrl="$value"
+ break
+ ;;
+ esac
+ done <"$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=$(cygpath --path --windows "$wrapperJarPath")
+ fi
+
+ if command -v wget >/dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath"
+ fi
+ elif command -v curl >/dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=$(cygpath --path --windows "$javaClass")
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=$(cygpath --path --windows "$M2_HOME")
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=$(cygpath --path --windows "$JAVA_HOME")
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=$(cygpath --path --windows "$CLASSPATH")
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=$(cygpath --path --windows "$MAVEN_PROJECTBASEDIR")
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/gateway/mvnw.cmd b/gateway/mvnw.cmd
new file mode 100644
index 0000000..c8d4337
--- /dev/null
+++ b/gateway/mvnw.cmd
@@ -0,0 +1,182 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+
+FOR /F "tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
+
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
+
+exit /B %ERROR_CODE%
diff --git a/gateway/pom.xml b/gateway/pom.xml
new file mode 100644
index 0000000..b7199d0
--- /dev/null
+++ b/gateway/pom.xml
@@ -0,0 +1,90 @@
+
+
+ 4.0.0
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.3.6.RELEASE
+
+
+ com.auth
+ gateway
+ 0.0.1-SNAPSHOT
+ gateway
+ Demo project for Spring Boot
+
+
+ 11
+ Hoxton.SR5
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter
+
+
+ org.springframework.boot
+ spring-boot-starter-validation
+
+
+
+
+
+ org.springframework.cloud
+ spring-cloud-starter-netflix-zuul
+
+
+ org.springframework.cloud
+ spring-cloud-starter-netflix-eureka-client
+
+
+
+
+
+ org.springframework.cloud
+ spring-cloud-starter-oauth2
+
+
+
+
+
+ org.projectlombok
+ lombok
+ true
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+
+
+
+
+
+ org.springframework.cloud
+ spring-cloud-dependencies
+ ${spring-cloud.version}
+ pom
+ import
+
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+
+
diff --git a/gateway/src/main/java/com/auth/gateway/GatewayApplication.java b/gateway/src/main/java/com/auth/gateway/GatewayApplication.java
new file mode 100644
index 0000000..670f504
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/GatewayApplication.java
@@ -0,0 +1,15 @@
+package com.auth.gateway;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
+import org.springframework.cloud.netflix.zuul.EnableZuulProxy;
+
+@EnableEurekaClient
+@EnableZuulProxy
+@SpringBootApplication
+public class GatewayApplication {
+ public static void main(String[] args) {
+ SpringApplication.run(GatewayApplication.class, args);
+ }
+}
diff --git a/gateway/src/main/java/com/auth/gateway/ResourceServerConfig.java b/gateway/src/main/java/com/auth/gateway/ResourceServerConfig.java
new file mode 100644
index 0000000..36fdf7f
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/ResourceServerConfig.java
@@ -0,0 +1,26 @@
+package com.auth.gateway;
+
+import org.springframework.context.annotation.Configuration;
+import org.springframework.security.config.annotation.web.builders.HttpSecurity;
+import org.springframework.security.oauth2.config.annotation.web.configuration.EnableResourceServer;
+import org.springframework.security.oauth2.config.annotation.web.configuration.ResourceServerConfigurerAdapter;
+
+@EnableResourceServer
+@Configuration
+class ResourceServerConfig extends ResourceServerConfigurerAdapter {
+ @Override
+ public void configure(HttpSecurity http) throws Exception {
+ http.authorizeRequests()
+ /* auth 서버 인증 설정 */
+ .antMatchers("/oauth/**").permitAll()
+ .antMatchers("/api/login/**").permitAll()
+ .antMatchers("/api/refresh/**").permitAll()
+ /* auth 서버 인증 설정 끝*/
+ /* 회원 서버 인증 설정 */
+ .antMatchers("/api/signup/**").permitAll()
+ /* 회원 서버 인증 설정 끝*/
+ /* 기타 설정 */
+ .antMatchers("/api/**").authenticated();
+ /* 기타 설정 끝*/
+ }
+}
\ No newline at end of file
diff --git a/gateway/src/main/java/com/auth/gateway/common/config/AppConfig.java b/gateway/src/main/java/com/auth/gateway/common/config/AppConfig.java
new file mode 100644
index 0000000..da3b4af
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/common/config/AppConfig.java
@@ -0,0 +1,22 @@
+package com.auth.gateway.common.config;
+
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Configuration;
+import org.springframework.web.client.RestTemplate;
+import org.springframework.web.servlet.config.annotation.CorsRegistry;
+import org.springframework.web.servlet.config.annotation.EnableWebMvc;
+import org.springframework.web.servlet.config.annotation.WebMvcConfigurer;
+
+@EnableWebMvc
+@Configuration
+public class AppConfig implements WebMvcConfigurer {
+ @Bean
+ public RestTemplate restTemplate() {
+ return new RestTemplate();
+ }
+ @Override
+ public void addCorsMappings(CorsRegistry registry) {
+ registry.addMapping("/**")
+ .allowedOrigins("*");
+ }
+}
diff --git a/gateway/src/main/java/com/auth/gateway/common/config/CorsFilter.java b/gateway/src/main/java/com/auth/gateway/common/config/CorsFilter.java
new file mode 100644
index 0000000..fb1cad8
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/common/config/CorsFilter.java
@@ -0,0 +1,41 @@
+package com.auth.gateway.common.config;
+
+import org.springframework.core.Ordered;
+import org.springframework.core.annotation.Order;
+import org.springframework.stereotype.Component;
+
+import javax.servlet.*;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+import java.io.IOException;
+
+@Component
+@Order(Ordered.HIGHEST_PRECEDENCE)
+public class CorsFilter implements Filter {
+ public void doFilter(ServletRequest req, ServletResponse res, FilterChain chain)
+ throws IOException, ServletException
+ {
+ HttpServletResponse response = (HttpServletResponse) res;
+ HttpServletRequest request = (HttpServletRequest) req;
+ response.setHeader("Access-Control-Allow-Origin", "*");
+ response.setHeader("Access-Control-Allow-Credentials", "true");
+ response.setHeader("Access-Control-Allow-Methods","*");
+ response.setHeader("Access-Control-Max-Age", "3600");
+ response.setHeader("Access-Control-Allow-Headers",
+ "Origin, X-Requested-With, Content-Type, Accept, Key, Authorization");
+
+ if ("OPTIONS".equalsIgnoreCase(request.getMethod())) {
+ response.setStatus(HttpServletResponse.SC_OK);
+ } else {
+ chain.doFilter(req, res);
+ }
+ }
+
+ public void init(FilterConfig filterConfig) {
+ // not needed
+ }
+
+ public void destroy() {
+ //not needed
+ }
+}
\ No newline at end of file
diff --git a/gateway/src/main/java/com/auth/gateway/common/constants/ErrorEnum.java b/gateway/src/main/java/com/auth/gateway/common/constants/ErrorEnum.java
new file mode 100644
index 0000000..e28a7d9
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/common/constants/ErrorEnum.java
@@ -0,0 +1,48 @@
+package com.auth.gateway.common.constants;
+
+import lombok.AllArgsConstructor;
+import lombok.Getter;
+import org.springframework.http.HttpStatus;
+
+@Getter
+@AllArgsConstructor
+public enum ErrorEnum {
+ /* 로그인 오류 메세지 정의 */
+ LOG_NOT_FOUND(HttpStatus.NOT_FOUND, "LOG_000", "해당 로그인을 처리할 수 없습니다."),
+ /* 로그인 오류 메세지 정의 끝*/
+
+ /* 기타 오류 메세지 정의 */
+ ETC(HttpStatus.INTERNAL_SERVER_ERROR, "ETC_000", "알 수 없는 오류입니다.");
+ /* 기타 오류 메세지 정의 끝*/
+
+ private final ErrorResponse errorResponse;
+
+ public String getMessage() {
+ return this.errorResponse.getMessage();
+ }
+
+ public String getErrCode() {
+ return this.errorResponse.getErrCode();
+ }
+
+ public HttpStatus getHttpStatus() {
+ return this.errorResponse.getHttpStatus();
+ }
+
+ ErrorEnum(HttpStatus httpStatus, String errCode, String message) {
+ this.errorResponse = new ErrorResponse(httpStatus, errCode, message);
+ }
+
+ @Getter
+ public static class ErrorResponse {
+ private final HttpStatus httpStatus;
+ private final String errCode;
+ private final String message;
+
+ public ErrorResponse(HttpStatus httpStatus, String errCode, String message) {
+ this.httpStatus = httpStatus;
+ this.errCode = errCode;
+ this.message = message;
+ }
+ }
+}
diff --git a/gateway/src/main/java/com/auth/gateway/common/exception/CustomException.java b/gateway/src/main/java/com/auth/gateway/common/exception/CustomException.java
new file mode 100644
index 0000000..99dd629
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/common/exception/CustomException.java
@@ -0,0 +1,17 @@
+package com.auth.gateway.common.exception;
+
+import com.auth.gateway.common.constants.ErrorEnum;
+import lombok.Getter;
+import org.springframework.http.HttpStatus;
+
+@Getter
+public class CustomException extends RuntimeException{
+ protected HttpStatus status;
+ protected ErrorEnum errorEnum;
+
+ public CustomException(ErrorEnum errorEnum) {
+ super(errorEnum.toString());
+ this.status = errorEnum.getErrorResponse().getHttpStatus();
+ this.errorEnum = errorEnum;
+ }
+}
\ No newline at end of file
diff --git a/gateway/src/main/java/com/auth/gateway/common/exception/GlobalExceptionHandler.java b/gateway/src/main/java/com/auth/gateway/common/exception/GlobalExceptionHandler.java
new file mode 100644
index 0000000..fb51399
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/common/exception/GlobalExceptionHandler.java
@@ -0,0 +1,31 @@
+package com.auth.gateway.common.exception;
+
+import com.auth.gateway.common.constants.ErrorEnum;
+import lombok.extern.slf4j.Slf4j;
+import org.springframework.web.bind.annotation.ExceptionHandler;
+import org.springframework.web.bind.annotation.RestControllerAdvice;
+import org.springframework.web.servlet.mvc.method.annotation.ResponseEntityExceptionHandler;
+
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+import java.io.IOException;
+
+@Slf4j
+@RestControllerAdvice
+public class GlobalExceptionHandler extends ResponseEntityExceptionHandler {
+
+ @ExceptionHandler({ CustomException.class })
+ public void handleCustomException(HttpServletRequest request, HttpServletResponse response, CustomException ex) throws IOException {
+ ErrorEnum errorEnum = ex.getErrorEnum();
+ response.sendError(ex.getStatus().value(), errorEnum.getMessage());
+ log.error("{} 시스템 오류 감지 : {}", errorEnum.getErrCode(), errorEnum.getMessage(), ex);
+ }
+
+ @ExceptionHandler({ Exception.class })
+ public void handleException(HttpServletRequest request, HttpServletResponse response, Exception ex) throws IOException {
+ ex.printStackTrace();
+
+ response.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "서버 내부 오류입니다.");
+ logger.error("알 수 없는 오류 감지.", ex);
+ }
+}
\ No newline at end of file
diff --git a/gateway/src/main/java/com/auth/gateway/controller/LoginController.java b/gateway/src/main/java/com/auth/gateway/controller/LoginController.java
new file mode 100644
index 0000000..509b35e
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/controller/LoginController.java
@@ -0,0 +1,44 @@
+package com.auth.gateway.controller;
+
+import com.auth.gateway.dto.LoginRequest;
+import com.auth.gateway.service.LoginService;
+import lombok.RequiredArgsConstructor;
+import lombok.extern.slf4j.Slf4j;
+import org.springframework.http.HttpStatus;
+import org.springframework.http.ResponseEntity;
+import org.springframework.validation.Errors;
+import org.springframework.web.bind.annotation.PostMapping;
+import org.springframework.web.bind.annotation.RequestBody;
+import org.springframework.web.bind.annotation.RequestParam;
+import org.springframework.web.bind.annotation.RestController;
+
+import javax.servlet.http.HttpServletResponse;
+import javax.validation.Valid;
+import java.util.Objects;
+
+@Slf4j
+@RequiredArgsConstructor
+@RestController
+public class LoginController {
+ private final LoginService loginService;
+
+ @PostMapping("/api/login")
+ public ResponseEntity> loginUser(@RequestBody @Valid LoginRequest loginRequest,
+ HttpServletResponse httpServletResponse, Errors error){
+ if(error.hasErrors()) {
+ String errMsg = Objects.requireNonNull(error.getFieldError()).getDefaultMessage();
+ log.info(errMsg);
+ return ResponseEntity.status(HttpStatus.BAD_REQUEST).body(errMsg);
+ }
+
+ String auth = loginService.getJwtByUserInfo(loginRequest);
+
+ return ResponseEntity.ok(auth);
+ }
+
+ @PostMapping("/api/refresh")
+ public ResponseEntity> getJwtByRefreshToken(@RequestParam(required = true) String refreshToken){
+ String auth = loginService.getJwtByRefreshToken(refreshToken);
+ return ResponseEntity.ok(auth);
+ }
+}
diff --git a/gateway/src/main/java/com/auth/gateway/dto/LoginRequest.java b/gateway/src/main/java/com/auth/gateway/dto/LoginRequest.java
new file mode 100644
index 0000000..3aba7c0
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/dto/LoginRequest.java
@@ -0,0 +1,15 @@
+package com.auth.gateway.dto;
+
+import lombok.Getter;
+
+import javax.validation.constraints.Email;
+import javax.validation.constraints.NotBlank;
+
+@Getter
+public class LoginRequest {
+ @Email(message = "이메일 형식이 아닙니다.")
+ @NotBlank(message = "이메일은 필수 입력값입니다.")
+ private String email;
+ @NotBlank(message = "비밀번호는 필수 입력값입니다.")
+ private String password;
+}
diff --git a/gateway/src/main/java/com/auth/gateway/service/LoginService.java b/gateway/src/main/java/com/auth/gateway/service/LoginService.java
new file mode 100644
index 0000000..1671f54
--- /dev/null
+++ b/gateway/src/main/java/com/auth/gateway/service/LoginService.java
@@ -0,0 +1,86 @@
+package com.auth.gateway.service;
+
+import com.auth.gateway.common.constants.ErrorEnum;
+import com.auth.gateway.common.exception.CustomException;
+import com.auth.gateway.dto.LoginRequest;
+import lombok.RequiredArgsConstructor;
+import org.apache.commons.codec.binary.Base64;
+import org.springframework.beans.factory.annotation.Value;
+import org.springframework.http.*;
+import org.springframework.stereotype.Service;
+import org.springframework.util.LinkedMultiValueMap;
+import org.springframework.util.MultiValueMap;
+import org.springframework.web.client.RestTemplate;
+
+import java.net.URI;
+
+@RequiredArgsConstructor
+@Service
+public class LoginService {
+ private final RestTemplate restTemplate;
+ @Value("${security.oauth2.client.client-id}")
+ private String CLIENT_ID;
+ @Value("${security.oauth2.client.client-secret}")
+ private String CLIENT_SECRET;
+ @Value("${server.port}")
+ private String port;
+
+ public String getJwtByUserInfo(LoginRequest loginRequest){
+ final String GRANT_TYPE = "password";
+ final String SERVER_URL = "http://localhost:" + port;
+ final String API_OAUTH_TOKEN = "/oauth/token";
+ final String SCOPE = "read";
+
+ String clientCredentials = CLIENT_ID+":"+ CLIENT_SECRET;
+ String base64ClientCredentials = new String(Base64.encodeBase64(clientCredentials.getBytes()));
+
+ HttpHeaders headers = new HttpHeaders();
+ headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
+ headers.add("Authorization", "Basic " + base64ClientCredentials);
+
+ MultiValueMap
parameters = new LinkedMultiValueMap<>();
+ parameters.add("grant_type", GRANT_TYPE);
+ parameters.add("username", loginRequest.getEmail());
+ parameters.add("password", loginRequest.getPassword());
+ parameters.add("scope", SCOPE);
+
+ HttpEntity> request = new HttpEntity<>(parameters, headers);
+ URI uri = URI.create(SERVER_URL+API_OAUTH_TOKEN);
+ ResponseEntity response = restTemplate.postForEntity(uri, request, String.class);
+
+ if(response.getStatusCode() != HttpStatus.OK){
+ throw new CustomException(ErrorEnum.LOG_NOT_FOUND);
+ }
+
+ return response.getBody();
+ }
+
+ public String getJwtByRefreshToken(String refreshToken){
+ final String GRANT_TYPE = "refresh_token";
+ final String SERVER_URL = "http://localhost:" + port;
+ final String API_OAUTH_TOKEN = "/oauth/token";
+ final String SCOPE = "read";
+
+ String clientCredentials = CLIENT_ID+":"+ CLIENT_SECRET;
+ String base64ClientCredentials = new String(Base64.encodeBase64(clientCredentials.getBytes()));
+
+ HttpHeaders headers = new HttpHeaders();
+ headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
+ headers.add("Authorization", "Basic " + base64ClientCredentials);
+
+ MultiValueMap parameters = new LinkedMultiValueMap<>();
+ parameters.add("grant_type", GRANT_TYPE);
+ parameters.add("refresh_token", refreshToken);
+ parameters.add("scope", SCOPE);
+
+ HttpEntity> request = new HttpEntity<>(parameters, headers);
+ URI uri = URI.create(SERVER_URL+API_OAUTH_TOKEN);
+ ResponseEntity response = restTemplate.postForEntity(uri, request, String.class);
+
+ if(response.getStatusCode() != HttpStatus.OK){
+ throw new CustomException(ErrorEnum.LOG_NOT_FOUND);
+ }
+
+ return response.getBody();
+ }
+}
diff --git a/gateway/src/main/resources/application.yml b/gateway/src/main/resources/application.yml
new file mode 100644
index 0000000..23928eb
--- /dev/null
+++ b/gateway/src/main/resources/application.yml
@@ -0,0 +1,55 @@
+server:
+ port: 8090
+
+eureka:
+ client:
+ serviceUrl:
+ defaultZone: http://localhost:8761/eureka/
+
+spring:
+ application:
+ name: msa-gateway
+
+zuul:
+ sensitiveHeaders: 'Cookie,Set-Cookie'
+ ignoredServices: '*'
+ #라우팅 설정
+ # user-server 라우팅
+ routes:
+ user:
+ path: /api/user/**
+ service-id: user-server
+ stripPrefix: false
+ signup:
+ path: /api/signup/**
+ service-id: user-server
+ stripPrefix: false
+ # user-server 라우팅 끝
+ # auth-server 라우팅
+ oauth:
+ path: /oauth/**
+ service-id: auth-server
+ stripPrefix: false
+ # auth-server 라우팅 끝
+ #라우팅 설정 끝
+
+#timeout setting
+user-server:
+ ribbon:
+ ConnectTimeout: 15000
+ ReadTimeout: 15000
+auth-server:
+ ribbon:
+ ConnectTimeout: 15000
+ ReadTimeout: 15000
+
+
+#security
+security:
+ oauth2:
+ client:
+ client-id: auth_id
+ client-secret: auth_secret
+ resource:
+ jwt:
+ key-value: jwt_secret_key
diff --git a/gateway/src/test/java/com/auth/gateway/GatewayApplicationTests.java b/gateway/src/test/java/com/auth/gateway/GatewayApplicationTests.java
new file mode 100644
index 0000000..6bccb21
--- /dev/null
+++ b/gateway/src/test/java/com/auth/gateway/GatewayApplicationTests.java
@@ -0,0 +1,13 @@
+package com.auth.gateway;
+
+import org.junit.jupiter.api.Test;
+import org.springframework.boot.test.context.SpringBootTest;
+
+@SpringBootTest
+class GatewayApplicationTests {
+
+ @Test
+ void contextLoads() {
+ }
+
+}
diff --git a/user-server/.gitattributes b/user-server/.gitattributes
new file mode 100644
index 0000000..dfe0770
--- /dev/null
+++ b/user-server/.gitattributes
@@ -0,0 +1,2 @@
+# Auto detect text files and perform LF normalization
+* text=auto
diff --git a/user-server/.gitignore b/user-server/.gitignore
new file mode 100644
index 0000000..d27eaaf
--- /dev/null
+++ b/user-server/.gitignore
@@ -0,0 +1,36 @@
+HELP.md
+target/
+!.mvn/wrapper/maven-wrapper.jar
+!**/src/main/**/target/
+!**/src/test/**/target/
+
+### STS ###
+.apt_generated
+.classpath
+.factorypath
+.project
+.settings
+.springBeans
+.sts4-cache
+
+### IntelliJ IDEA ###
+.idea
+*.iws
+*.iml
+*.ipr
+
+### NetBeans ###
+/nbproject/private/
+/nbbuild/
+/dist/
+/nbdist/
+/.nb-gradle/
+build/
+!**/src/main/**/build/
+!**/src/test/**/build/
+
+### VS Code ###
+.vscode/
+
+# 사용자정의
+/src/main/resources/application.yml
\ No newline at end of file
diff --git a/user-server/.mvn/wrapper/MavenWrapperDownloader.java b/user-server/.mvn/wrapper/MavenWrapperDownloader.java
new file mode 100644
index 0000000..a45eb6b
--- /dev/null
+++ b/user-server/.mvn/wrapper/MavenWrapperDownloader.java
@@ -0,0 +1,118 @@
+/*
+ * Copyright 2007-present the original author or authors.
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ * https://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS,
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+import java.net.*;
+import java.io.*;
+import java.nio.channels.*;
+import java.util.Properties;
+
+public class MavenWrapperDownloader {
+
+ private static final String WRAPPER_VERSION = "0.5.6";
+ /**
+ * Default URL to download the maven-wrapper.jar from, if no 'downloadUrl' is provided.
+ */
+ private static final String DEFAULT_DOWNLOAD_URL = "https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/"
+ + WRAPPER_VERSION + "/maven-wrapper-" + WRAPPER_VERSION + ".jar";
+
+ /**
+ * Path to the maven-wrapper.properties file, which might contain a downloadUrl property to
+ * use instead of the default one.
+ */
+ private static final String MAVEN_WRAPPER_PROPERTIES_PATH =
+ ".mvn/wrapper/maven-wrapper.properties";
+
+ /**
+ * Path where the maven-wrapper.jar will be saved to.
+ */
+ private static final String MAVEN_WRAPPER_JAR_PATH =
+ ".mvn/wrapper/maven-wrapper.jar";
+
+ /**
+ * Name of the property which should be used to override the default download url for the wrapper.
+ */
+ private static final String PROPERTY_NAME_WRAPPER_URL = "wrapperUrl";
+
+ public static void main(String args[]) {
+ System.out.println("- Downloader started");
+ File baseDirectory = new File(args[0]);
+ System.out.println("- Using base directory: " + baseDirectory.getAbsolutePath());
+
+ // If the maven-wrapper.properties exists, read it and check if it contains a custom
+ // wrapperUrl parameter.
+ File mavenWrapperPropertyFile = new File(baseDirectory, MAVEN_WRAPPER_PROPERTIES_PATH);
+ String url = DEFAULT_DOWNLOAD_URL;
+ if (mavenWrapperPropertyFile.exists()) {
+ FileInputStream mavenWrapperPropertyFileInputStream = null;
+ try {
+ mavenWrapperPropertyFileInputStream = new FileInputStream(mavenWrapperPropertyFile);
+ Properties mavenWrapperProperties = new Properties();
+ mavenWrapperProperties.load(mavenWrapperPropertyFileInputStream);
+ url = mavenWrapperProperties.getProperty(PROPERTY_NAME_WRAPPER_URL, url);
+ } catch (IOException e) {
+ System.out.println("- ERROR loading '" + MAVEN_WRAPPER_PROPERTIES_PATH + "'");
+ } finally {
+ try {
+ if (mavenWrapperPropertyFileInputStream != null) {
+ mavenWrapperPropertyFileInputStream.close();
+ }
+ } catch (IOException e) {
+ // Ignore ...
+ }
+ }
+ }
+ System.out.println("- Downloading from: " + url);
+
+ File outputFile = new File(baseDirectory.getAbsolutePath(), MAVEN_WRAPPER_JAR_PATH);
+ if (!outputFile.getParentFile().exists()) {
+ if (!outputFile.getParentFile().mkdirs()) {
+ System.out.println(
+ "- ERROR creating output directory '" + outputFile.getParentFile().getAbsolutePath() + "'");
+ }
+ }
+ System.out.println("- Downloading to: " + outputFile.getAbsolutePath());
+ try {
+ downloadFileFromURL(url, outputFile);
+ System.out.println("Done");
+ System.exit(0);
+ } catch (Throwable e) {
+ System.out.println("- Error downloading");
+ e.printStackTrace();
+ System.exit(1);
+ }
+ }
+
+ private static void downloadFileFromURL(String urlString, File destination) throws Exception {
+ if (System.getenv("MVNW_USERNAME") != null && System.getenv("MVNW_PASSWORD") != null) {
+ String username = System.getenv("MVNW_USERNAME");
+ char[] password = System.getenv("MVNW_PASSWORD").toCharArray();
+ Authenticator.setDefault(new Authenticator() {
+ @Override
+ protected PasswordAuthentication getPasswordAuthentication() {
+ return new PasswordAuthentication(username, password);
+ }
+ });
+ }
+ URL website = new URL(urlString);
+ ReadableByteChannel rbc;
+ rbc = Channels.newChannel(website.openStream());
+ FileOutputStream fos = new FileOutputStream(destination);
+ fos.getChannel().transferFrom(rbc, 0, Long.MAX_VALUE);
+ fos.close();
+ rbc.close();
+ }
+
+}
diff --git a/user-server/.mvn/wrapper/maven-wrapper.jar b/user-server/.mvn/wrapper/maven-wrapper.jar
new file mode 100644
index 0000000..2cc7d4a
Binary files /dev/null and b/user-server/.mvn/wrapper/maven-wrapper.jar differ
diff --git a/user-server/.mvn/wrapper/maven-wrapper.properties b/user-server/.mvn/wrapper/maven-wrapper.properties
new file mode 100644
index 0000000..642d572
--- /dev/null
+++ b/user-server/.mvn/wrapper/maven-wrapper.properties
@@ -0,0 +1,2 @@
+distributionUrl=https://repo.maven.apache.org/maven2/org/apache/maven/apache-maven/3.6.3/apache-maven-3.6.3-bin.zip
+wrapperUrl=https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar
diff --git a/user-server/mvnw b/user-server/mvnw
new file mode 100644
index 0000000..3c8a553
--- /dev/null
+++ b/user-server/mvnw
@@ -0,0 +1,322 @@
+#!/bin/sh
+# ----------------------------------------------------------------------------
+# Licensed to the Apache Software Foundation (ASF) under one
+# or more contributor license agreements. See the NOTICE file
+# distributed with this work for additional information
+# regarding copyright ownership. The ASF licenses this file
+# to you under the Apache License, Version 2.0 (the
+# "License"); you may not use this file except in compliance
+# with the License. You may obtain a copy of the License at
+#
+# https://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing,
+# software distributed under the License is distributed on an
+# "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+# KIND, either express or implied. See the License for the
+# specific language governing permissions and limitations
+# under the License.
+# ----------------------------------------------------------------------------
+
+# ----------------------------------------------------------------------------
+# Maven Start Up Batch script
+#
+# Required ENV vars:
+# ------------------
+# JAVA_HOME - location of a JDK home dir
+#
+# Optional ENV vars
+# -----------------
+# M2_HOME - location of maven2's installed home dir
+# MAVEN_OPTS - parameters passed to the Java VM when running Maven
+# e.g. to debug Maven itself, use
+# set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+# MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+# ----------------------------------------------------------------------------
+
+if [ -z "$MAVEN_SKIP_RC" ]; then
+
+ if [ -f /etc/mavenrc ]; then
+ . /etc/mavenrc
+ fi
+
+ if [ -f "$HOME/.mavenrc" ]; then
+ . "$HOME/.mavenrc"
+ fi
+
+fi
+
+# OS specific support. $var _must_ be set to either true or false.
+cygwin=false
+darwin=false
+mingw=false
+case "$(uname)" in
+CYGWIN*) cygwin=true ;;
+MINGW*) mingw=true ;;
+Darwin*)
+ darwin=true
+ # Use /usr/libexec/java_home if available, otherwise fall back to /Library/Java/Home
+ # See https://developer.apple.com/library/mac/qa/qa1170/_index.html
+ if [ -z "$JAVA_HOME" ]; then
+ if [ -x "/usr/libexec/java_home" ]; then
+ export JAVA_HOME="$(/usr/libexec/java_home)"
+ else
+ export JAVA_HOME="/Library/Java/Home"
+ fi
+ fi
+ ;;
+esac
+
+if [ -z "$JAVA_HOME" ]; then
+ if [ -r /etc/gentoo-release ]; then
+ JAVA_HOME=$(java-config --jre-home)
+ fi
+fi
+
+if [ -z "$M2_HOME" ]; then
+ ## resolve links - $0 may be a link to maven's home
+ PRG="$0"
+
+ # need this for relative symlinks
+ while [ -h "$PRG" ]; do
+ ls=$(ls -ld "$PRG")
+ link=$(expr "$ls" : '.*-> \(.*\)$')
+ if expr "$link" : '/.*' >/dev/null; then
+ PRG="$link"
+ else
+ PRG="$(dirname "$PRG")/$link"
+ fi
+ done
+
+ saveddir=$(pwd)
+
+ M2_HOME=$(dirname "$PRG")/..
+
+ # make it fully qualified
+ M2_HOME=$(cd "$M2_HOME" && pwd)
+
+ cd "$saveddir"
+ # echo Using m2 at $M2_HOME
+fi
+
+# For Cygwin, ensure paths are in UNIX format before anything is touched
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=$(cygpath --unix "$M2_HOME")
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=$(cygpath --unix "$JAVA_HOME")
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=$(cygpath --path --unix "$CLASSPATH")
+fi
+
+# For Mingw, ensure paths are in UNIX format before anything is touched
+if $mingw; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME="$( (
+ cd "$M2_HOME"
+ pwd
+ ))"
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME="$( (
+ cd "$JAVA_HOME"
+ pwd
+ ))"
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ javaExecutable="$(which javac)"
+ if [ -n "$javaExecutable" ] && ! [ "$(expr \"$javaExecutable\" : '\([^ ]*\)')" = "no" ]; then
+ # readlink(1) is not available as standard on Solaris 10.
+ readLink=$(which readlink)
+ if [ ! $(expr "$readLink" : '\([^ ]*\)') = "no" ]; then
+ if $darwin; then
+ javaHome="$(dirname \"$javaExecutable\")"
+ javaExecutable="$(cd \"$javaHome\" && pwd -P)/javac"
+ else
+ javaExecutable="$(readlink -f \"$javaExecutable\")"
+ fi
+ javaHome="$(dirname \"$javaExecutable\")"
+ javaHome=$(expr "$javaHome" : '\(.*\)/bin')
+ JAVA_HOME="$javaHome"
+ export JAVA_HOME
+ fi
+ fi
+fi
+
+if [ -z "$JAVACMD" ]; then
+ if [ -n "$JAVA_HOME" ]; then
+ if [ -x "$JAVA_HOME/jre/sh/java" ]; then
+ # IBM's JDK on AIX uses strange locations for the executables
+ JAVACMD="$JAVA_HOME/jre/sh/java"
+ else
+ JAVACMD="$JAVA_HOME/bin/java"
+ fi
+ else
+ JAVACMD="$(which java)"
+ fi
+fi
+
+if [ ! -x "$JAVACMD" ]; then
+ echo "Error: JAVA_HOME is not defined correctly." >&2
+ echo " We cannot execute $JAVACMD" >&2
+ exit 1
+fi
+
+if [ -z "$JAVA_HOME" ]; then
+ echo "Warning: JAVA_HOME environment variable is not set."
+fi
+
+CLASSWORLDS_LAUNCHER=org.codehaus.plexus.classworlds.launcher.Launcher
+
+# traverses directory structure from process work directory to filesystem root
+# first directory with .mvn subdirectory is considered project base directory
+find_maven_basedir() {
+
+ if [ -z "$1" ]; then
+ echo "Path not specified to find_maven_basedir"
+ return 1
+ fi
+
+ basedir="$1"
+ wdir="$1"
+ while [ "$wdir" != '/' ]; do
+ if [ -d "$wdir"/.mvn ]; then
+ basedir=$wdir
+ break
+ fi
+ # workaround for JBEAP-8937 (on Solaris 10/Sparc)
+ if [ -d "${wdir}" ]; then
+ wdir=$(
+ cd "$wdir/.."
+ pwd
+ )
+ fi
+ # end of workaround
+ done
+ echo "${basedir}"
+}
+
+# concatenates all lines of a file
+concat_lines() {
+ if [ -f "$1" ]; then
+ echo "$(tr -s '\n' ' ' <"$1")"
+ fi
+}
+
+BASE_DIR=$(find_maven_basedir "$(pwd)")
+if [ -z "$BASE_DIR" ]; then
+ exit 1
+fi
+
+##########################################################################################
+# Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+# This allows using the maven wrapper in projects that prohibit checking in binary data.
+##########################################################################################
+if [ -r "$BASE_DIR/.mvn/wrapper/maven-wrapper.jar" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found .mvn/wrapper/maven-wrapper.jar"
+ fi
+else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Couldn't find .mvn/wrapper/maven-wrapper.jar, downloading it ..."
+ fi
+ if [ -n "$MVNW_REPOURL" ]; then
+ jarUrl="$MVNW_REPOURL/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+ else
+ jarUrl="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+ fi
+ while IFS="=" read key value; do
+ case "$key" in wrapperUrl)
+ jarUrl="$value"
+ break
+ ;;
+ esac
+ done <"$BASE_DIR/.mvn/wrapper/maven-wrapper.properties"
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Downloading from: $jarUrl"
+ fi
+ wrapperJarPath="$BASE_DIR/.mvn/wrapper/maven-wrapper.jar"
+ if $cygwin; then
+ wrapperJarPath=$(cygpath --path --windows "$wrapperJarPath")
+ fi
+
+ if command -v wget >/dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found wget ... using wget"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ wget "$jarUrl" -O "$wrapperJarPath"
+ else
+ wget --http-user=$MVNW_USERNAME --http-password=$MVNW_PASSWORD "$jarUrl" -O "$wrapperJarPath"
+ fi
+ elif command -v curl >/dev/null; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Found curl ... using curl"
+ fi
+ if [ -z "$MVNW_USERNAME" ] || [ -z "$MVNW_PASSWORD" ]; then
+ curl -o "$wrapperJarPath" "$jarUrl" -f
+ else
+ curl --user $MVNW_USERNAME:$MVNW_PASSWORD -o "$wrapperJarPath" "$jarUrl" -f
+ fi
+
+ else
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo "Falling back to using Java to download"
+ fi
+ javaClass="$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.java"
+ # For Cygwin, switch paths to Windows format before running javac
+ if $cygwin; then
+ javaClass=$(cygpath --path --windows "$javaClass")
+ fi
+ if [ -e "$javaClass" ]; then
+ if [ ! -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Compiling MavenWrapperDownloader.java ..."
+ fi
+ # Compiling the Java class
+ ("$JAVA_HOME/bin/javac" "$javaClass")
+ fi
+ if [ -e "$BASE_DIR/.mvn/wrapper/MavenWrapperDownloader.class" ]; then
+ # Running the downloader
+ if [ "$MVNW_VERBOSE" = true ]; then
+ echo " - Running MavenWrapperDownloader.java ..."
+ fi
+ ("$JAVA_HOME/bin/java" -cp .mvn/wrapper MavenWrapperDownloader "$MAVEN_PROJECTBASEDIR")
+ fi
+ fi
+ fi
+fi
+##########################################################################################
+# End of extension
+##########################################################################################
+
+export MAVEN_PROJECTBASEDIR=${MAVEN_BASEDIR:-"$BASE_DIR"}
+if [ "$MVNW_VERBOSE" = true ]; then
+ echo $MAVEN_PROJECTBASEDIR
+fi
+MAVEN_OPTS="$(concat_lines "$MAVEN_PROJECTBASEDIR/.mvn/jvm.config") $MAVEN_OPTS"
+
+# For Cygwin, switch paths to Windows format before running java
+if $cygwin; then
+ [ -n "$M2_HOME" ] &&
+ M2_HOME=$(cygpath --path --windows "$M2_HOME")
+ [ -n "$JAVA_HOME" ] &&
+ JAVA_HOME=$(cygpath --path --windows "$JAVA_HOME")
+ [ -n "$CLASSPATH" ] &&
+ CLASSPATH=$(cygpath --path --windows "$CLASSPATH")
+ [ -n "$MAVEN_PROJECTBASEDIR" ] &&
+ MAVEN_PROJECTBASEDIR=$(cygpath --path --windows "$MAVEN_PROJECTBASEDIR")
+fi
+
+# Provide a "standardized" way to retrieve the CLI args that will
+# work with both Windows and non-Windows executions.
+MAVEN_CMD_LINE_ARGS="$MAVEN_CONFIG $@"
+export MAVEN_CMD_LINE_ARGS
+
+WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+exec "$JAVACMD" \
+ $MAVEN_OPTS \
+ -classpath "$MAVEN_PROJECTBASEDIR/.mvn/wrapper/maven-wrapper.jar" \
+ "-Dmaven.home=${M2_HOME}" "-Dmaven.multiModuleProjectDirectory=${MAVEN_PROJECTBASEDIR}" \
+ ${WRAPPER_LAUNCHER} $MAVEN_CONFIG "$@"
diff --git a/user-server/mvnw.cmd b/user-server/mvnw.cmd
new file mode 100644
index 0000000..c8d4337
--- /dev/null
+++ b/user-server/mvnw.cmd
@@ -0,0 +1,182 @@
+@REM ----------------------------------------------------------------------------
+@REM Licensed to the Apache Software Foundation (ASF) under one
+@REM or more contributor license agreements. See the NOTICE file
+@REM distributed with this work for additional information
+@REM regarding copyright ownership. The ASF licenses this file
+@REM to you under the Apache License, Version 2.0 (the
+@REM "License"); you may not use this file except in compliance
+@REM with the License. You may obtain a copy of the License at
+@REM
+@REM https://www.apache.org/licenses/LICENSE-2.0
+@REM
+@REM Unless required by applicable law or agreed to in writing,
+@REM software distributed under the License is distributed on an
+@REM "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
+@REM KIND, either express or implied. See the License for the
+@REM specific language governing permissions and limitations
+@REM under the License.
+@REM ----------------------------------------------------------------------------
+
+@REM ----------------------------------------------------------------------------
+@REM Maven Start Up Batch script
+@REM
+@REM Required ENV vars:
+@REM JAVA_HOME - location of a JDK home dir
+@REM
+@REM Optional ENV vars
+@REM M2_HOME - location of maven2's installed home dir
+@REM MAVEN_BATCH_ECHO - set to 'on' to enable the echoing of the batch commands
+@REM MAVEN_BATCH_PAUSE - set to 'on' to wait for a keystroke before ending
+@REM MAVEN_OPTS - parameters passed to the Java VM when running Maven
+@REM e.g. to debug Maven itself, use
+@REM set MAVEN_OPTS=-Xdebug -Xrunjdwp:transport=dt_socket,server=y,suspend=y,address=8000
+@REM MAVEN_SKIP_RC - flag to disable loading of mavenrc files
+@REM ----------------------------------------------------------------------------
+
+@REM Begin all REM lines with '@' in case MAVEN_BATCH_ECHO is 'on'
+@echo off
+@REM set title of command window
+title %0
+@REM enable echoing by setting MAVEN_BATCH_ECHO to 'on'
+@if "%MAVEN_BATCH_ECHO%" == "on" echo %MAVEN_BATCH_ECHO%
+
+@REM set %HOME% to equivalent of $HOME
+if "%HOME%" == "" (set "HOME=%HOMEDRIVE%%HOMEPATH%")
+
+@REM Execute a user defined script before this one
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPre
+@REM check for pre script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_pre.bat" call "%HOME%\mavenrc_pre.bat"
+if exist "%HOME%\mavenrc_pre.cmd" call "%HOME%\mavenrc_pre.cmd"
+:skipRcPre
+
+@setlocal
+
+set ERROR_CODE=0
+
+@REM To isolate internal variables from possible post scripts, we use another setlocal
+@setlocal
+
+@REM ==== START VALIDATION ====
+if not "%JAVA_HOME%" == "" goto OkJHome
+
+echo.
+echo Error: JAVA_HOME not found in your environment. >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+:OkJHome
+if exist "%JAVA_HOME%\bin\java.exe" goto init
+
+echo.
+echo Error: JAVA_HOME is set to an invalid directory. >&2
+echo JAVA_HOME = "%JAVA_HOME%" >&2
+echo Please set the JAVA_HOME variable in your environment to match the >&2
+echo location of your Java installation. >&2
+echo.
+goto error
+
+@REM ==== END VALIDATION ====
+
+:init
+
+@REM Find the project base dir, i.e. the directory that contains the folder ".mvn".
+@REM Fallback to current working directory if not found.
+
+set MAVEN_PROJECTBASEDIR=%MAVEN_BASEDIR%
+IF NOT "%MAVEN_PROJECTBASEDIR%"=="" goto endDetectBaseDir
+
+set EXEC_DIR=%CD%
+set WDIR=%EXEC_DIR%
+:findBaseDir
+IF EXIST "%WDIR%"\.mvn goto baseDirFound
+cd ..
+IF "%WDIR%"=="%CD%" goto baseDirNotFound
+set WDIR=%CD%
+goto findBaseDir
+
+:baseDirFound
+set MAVEN_PROJECTBASEDIR=%WDIR%
+cd "%EXEC_DIR%"
+goto endDetectBaseDir
+
+:baseDirNotFound
+set MAVEN_PROJECTBASEDIR=%EXEC_DIR%
+cd "%EXEC_DIR%"
+
+:endDetectBaseDir
+
+IF NOT EXIST "%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config" goto endReadAdditionalConfig
+
+@setlocal EnableExtensions EnableDelayedExpansion
+for /F "usebackq delims=" %%a in ("%MAVEN_PROJECTBASEDIR%\.mvn\jvm.config") do set JVM_CONFIG_MAVEN_PROPS=!JVM_CONFIG_MAVEN_PROPS! %%a
+@endlocal & set JVM_CONFIG_MAVEN_PROPS=%JVM_CONFIG_MAVEN_PROPS%
+
+:endReadAdditionalConfig
+
+SET MAVEN_JAVA_EXE="%JAVA_HOME%\bin\java.exe"
+set WRAPPER_JAR="%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.jar"
+set WRAPPER_LAUNCHER=org.apache.maven.wrapper.MavenWrapperMain
+
+set DOWNLOAD_URL="https://repo.maven.apache.org/maven2/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+
+FOR /F "tokens=1,2 delims==" %%A IN ("%MAVEN_PROJECTBASEDIR%\.mvn\wrapper\maven-wrapper.properties") DO (
+ IF "%%A"=="wrapperUrl" SET DOWNLOAD_URL=%%B
+)
+
+@REM Extension to allow automatically downloading the maven-wrapper.jar from Maven-central
+@REM This allows using the maven wrapper in projects that prohibit checking in binary data.
+if exist %WRAPPER_JAR% (
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Found %WRAPPER_JAR%
+ )
+) else (
+ if not "%MVNW_REPOURL%" == "" (
+ SET DOWNLOAD_URL="%MVNW_REPOURL%/io/takari/maven-wrapper/0.5.6/maven-wrapper-0.5.6.jar"
+ )
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Couldn't find %WRAPPER_JAR%, downloading it ...
+ echo Downloading from: %DOWNLOAD_URL%
+ )
+
+ powershell -Command "&{"^
+ "$webclient = new-object System.Net.WebClient;"^
+ "if (-not ([string]::IsNullOrEmpty('%MVNW_USERNAME%') -and [string]::IsNullOrEmpty('%MVNW_PASSWORD%'))) {"^
+ "$webclient.Credentials = new-object System.Net.NetworkCredential('%MVNW_USERNAME%', '%MVNW_PASSWORD%');"^
+ "}"^
+ "[Net.ServicePointManager]::SecurityProtocol = [Net.SecurityProtocolType]::Tls12; $webclient.DownloadFile('%DOWNLOAD_URL%', '%WRAPPER_JAR%')"^
+ "}"
+ if "%MVNW_VERBOSE%" == "true" (
+ echo Finished downloading %WRAPPER_JAR%
+ )
+)
+@REM End of extension
+
+@REM Provide a "standardized" way to retrieve the CLI args that will
+@REM work with both Windows and non-Windows executions.
+set MAVEN_CMD_LINE_ARGS=%*
+
+%MAVEN_JAVA_EXE% %JVM_CONFIG_MAVEN_PROPS% %MAVEN_OPTS% %MAVEN_DEBUG_OPTS% -classpath %WRAPPER_JAR% "-Dmaven.multiModuleProjectDirectory=%MAVEN_PROJECTBASEDIR%" %WRAPPER_LAUNCHER% %MAVEN_CONFIG% %*
+if ERRORLEVEL 1 goto error
+goto end
+
+:error
+set ERROR_CODE=1
+
+:end
+@endlocal & set ERROR_CODE=%ERROR_CODE%
+
+if not "%MAVEN_SKIP_RC%" == "" goto skipRcPost
+@REM check for post script, once with legacy .bat ending and once with .cmd ending
+if exist "%HOME%\mavenrc_post.bat" call "%HOME%\mavenrc_post.bat"
+if exist "%HOME%\mavenrc_post.cmd" call "%HOME%\mavenrc_post.cmd"
+:skipRcPost
+
+@REM pause the script if MAVEN_BATCH_PAUSE is set to 'on'
+if "%MAVEN_BATCH_PAUSE%" == "on" pause
+
+if "%MAVEN_TERMINATE_CMD%" == "on" exit %ERROR_CODE%
+
+exit /B %ERROR_CODE%
diff --git a/user-server/pom.xml b/user-server/pom.xml
new file mode 100644
index 0000000..a00af2d
--- /dev/null
+++ b/user-server/pom.xml
@@ -0,0 +1,113 @@
+
+
+ 4.0.0
+
+ org.springframework.boot
+ spring-boot-starter-parent
+ 2.3.6.RELEASE
+
+
+ com.auth
+ user-server
+ 0.0.1-SNAPSHOT
+ user-server
+ Demo project for Spring Boot
+
+
+ 11
+ Hoxton.SR5
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-data-jpa
+
+
+ org.springframework.boot
+ spring-boot-starter-web
+
+
+ org.springframework.boot
+ spring-boot-starter-validation
+
+
+ org.springframework.boot
+ spring-boot-starter-mail
+
+
+ org.springframework.boot
+ spring-boot-starter-security
+
+
+
+
+
+ org.springframework.cloud
+ spring-cloud-starter-netflix-eureka-client
+
+
+
+
+
+ org.springframework.cloud
+ spring-cloud-starter-oauth2
+
+
+
+
+
+ org.projectlombok
+ lombok
+ true
+
+
+ mysql
+ mysql-connector-java
+ 8.0.22
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-starter-test
+ test
+
+
+
+
+
+
+
+ org.springframework.cloud
+ spring-cloud-dependencies
+ ${spring-cloud.version}
+ pom
+ import
+
+
+
+
+
+
+
+
+ org.springframework.boot
+ spring-boot-maven-plugin
+
+
+
+ org.projectlombok
+ lombok
+
+
+
+
+
+
+
+
diff --git a/user-server/src/main/java/com/auth/userserver/UserServerApplication.java b/user-server/src/main/java/com/auth/userserver/UserServerApplication.java
new file mode 100644
index 0000000..0334b43
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/UserServerApplication.java
@@ -0,0 +1,16 @@
+package com.auth.userserver;
+
+import org.springframework.boot.SpringApplication;
+import org.springframework.boot.autoconfigure.SpringBootApplication;
+import org.springframework.boot.autoconfigure.security.servlet.SecurityAutoConfiguration;
+import org.springframework.cache.annotation.EnableCaching;
+import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
+
+@EnableCaching
+@EnableEurekaClient
+@SpringBootApplication
+public class UserServerApplication {
+ public static void main(String[] args) {
+ SpringApplication.run(UserServerApplication.class, args);
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/common/config/ResourceServerConfig.java b/user-server/src/main/java/com/auth/userserver/common/config/ResourceServerConfig.java
new file mode 100644
index 0000000..625b319
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/common/config/ResourceServerConfig.java
@@ -0,0 +1,18 @@
+package com.auth.userserver.common.config;
+
+import org.springframework.context.annotation.Configuration;
+import org.springframework.security.config.annotation.web.builders.HttpSecurity;
+import org.springframework.security.oauth2.config.annotation.web.configuration.EnableResourceServer;
+import org.springframework.security.oauth2.config.annotation.web.configuration.ResourceServerConfigurerAdapter;
+
+@EnableResourceServer
+@Configuration
+public class ResourceServerConfig extends ResourceServerConfigurerAdapter {
+ @Override
+ public void configure(HttpSecurity http) throws Exception {
+ http.headers().frameOptions().disable();
+ http.authorizeRequests()
+ .antMatchers("/api/signup/**").permitAll()
+ .antMatchers("/api/user/**").hasAnyAuthority("ADMIN");
+ }
+}
\ No newline at end of file
diff --git a/user-server/src/main/java/com/auth/userserver/common/config/WebConfig.java b/user-server/src/main/java/com/auth/userserver/common/config/WebConfig.java
new file mode 100644
index 0000000..439d05b
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/common/config/WebConfig.java
@@ -0,0 +1,15 @@
+package com.auth.userserver.common.config;
+
+import org.springframework.context.annotation.Bean;
+import org.springframework.context.annotation.Configuration;
+import org.springframework.security.crypto.password.Pbkdf2PasswordEncoder;
+
+@Configuration
+public class WebConfig{
+ @Bean
+ public Pbkdf2PasswordEncoder getPasswordEncoder() {
+ Pbkdf2PasswordEncoder pbkdf2PasswordEncoder = new Pbkdf2PasswordEncoder();
+ pbkdf2PasswordEncoder.setAlgorithm(Pbkdf2PasswordEncoder.SecretKeyFactoryAlgorithm.PBKDF2WithHmacSHA256);
+ return pbkdf2PasswordEncoder;
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/common/constants/ErrorEnum.java b/user-server/src/main/java/com/auth/userserver/common/constants/ErrorEnum.java
new file mode 100644
index 0000000..c54e1cd
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/common/constants/ErrorEnum.java
@@ -0,0 +1,50 @@
+package com.auth.userserver.common.constants;
+
+import lombok.AllArgsConstructor;
+import lombok.Getter;
+import org.springframework.http.HttpStatus;
+
+@Getter
+@AllArgsConstructor
+public enum ErrorEnum {
+ /* 사용자 오류 메세지 정의 */
+ USER_ALREADY_EXIST(HttpStatus.BAD_REQUEST, "USER_000", "해당 아이디가 이미 존재합니다"),
+ USER_NOT_FOUND(HttpStatus.NOT_FOUND, "USER_001", "해당 아이디가 존재하지 않습니다."),
+ USER_ALREADY_CONFIRMED(HttpStatus.BAD_REQUEST, "USER_001", "해당 아이디가 이미 이메일 인증을 받았습니다."),
+ /* 사용자 오류 메세지 정의 끝*/
+
+ /* 기타 오류 메세지 정의 */
+ ETC(HttpStatus.INTERNAL_SERVER_ERROR, "ETC_000", "알 수 없는 오류입니다.");
+ /* 기타 오류 메세지 정의 끝*/
+
+ private final ErrorResponse errorResponse;
+
+ public String getMessage() {
+ return this.errorResponse.getMessage();
+ }
+
+ public String getErrCode() {
+ return this.errorResponse.getErrCode();
+ }
+
+ public HttpStatus getHttpStatus() {
+ return this.errorResponse.getHttpStatus();
+ }
+
+ ErrorEnum(HttpStatus httpStatus, String errCode, String message) {
+ this.errorResponse = new ErrorResponse(httpStatus, errCode, message);
+ }
+
+ @Getter
+ public static class ErrorResponse {
+ private final HttpStatus httpStatus;
+ private final String errCode;
+ private final String message;
+
+ public ErrorResponse(HttpStatus httpStatus, String errCode, String message) {
+ this.httpStatus = httpStatus;
+ this.errCode = errCode;
+ this.message = message;
+ }
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/common/exception/CustomException.java b/user-server/src/main/java/com/auth/userserver/common/exception/CustomException.java
new file mode 100644
index 0000000..99097f0
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/common/exception/CustomException.java
@@ -0,0 +1,17 @@
+package com.auth.userserver.common.exception;
+
+import com.auth.userserver.common.constants.ErrorEnum;
+import lombok.Getter;
+import org.springframework.http.HttpStatus;
+
+@Getter
+public class CustomException extends RuntimeException{
+ protected HttpStatus status;
+ protected ErrorEnum errorEnum;
+
+ public CustomException(ErrorEnum errorEnum) {
+ super(errorEnum.toString());
+ this.status = errorEnum.getErrorResponse().getHttpStatus();
+ this.errorEnum = errorEnum;
+ }
+}
\ No newline at end of file
diff --git a/user-server/src/main/java/com/auth/userserver/common/exception/GlobalExceptionHandler.java b/user-server/src/main/java/com/auth/userserver/common/exception/GlobalExceptionHandler.java
new file mode 100644
index 0000000..1a23b61
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/common/exception/GlobalExceptionHandler.java
@@ -0,0 +1,31 @@
+package com.auth.userserver.common.exception;
+
+import com.auth.userserver.common.constants.ErrorEnum;
+import lombok.extern.slf4j.Slf4j;
+import org.springframework.web.bind.annotation.ExceptionHandler;
+import org.springframework.web.bind.annotation.RestControllerAdvice;
+import org.springframework.web.servlet.mvc.method.annotation.ResponseEntityExceptionHandler;
+
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+import java.io.IOException;
+
+@Slf4j
+@RestControllerAdvice
+public class GlobalExceptionHandler extends ResponseEntityExceptionHandler {
+
+ @ExceptionHandler({ CustomException.class })
+ public void handleCustomException(HttpServletRequest request, HttpServletResponse response, CustomException ex) throws IOException {
+ ErrorEnum errorEnum = ex.getErrorEnum();
+ response.sendError(ex.getStatus().value(), errorEnum.getMessage());
+ log.error("{} 시스템 오류 감지 : {}", errorEnum.getErrCode(), errorEnum.getMessage(), ex);
+ }
+
+ @ExceptionHandler({ Exception.class })
+ public void handleException(HttpServletRequest request, HttpServletResponse response, Exception ex) throws IOException {
+ ex.printStackTrace();
+
+ response.sendError(HttpServletResponse.SC_INTERNAL_SERVER_ERROR, "서버 내부 오류입니다.");
+ logger.error("알 수 없는 오류 감지.", ex);
+ }
+}
\ No newline at end of file
diff --git a/user-server/src/main/java/com/auth/userserver/common/util/URLCombiner.java b/user-server/src/main/java/com/auth/userserver/common/util/URLCombiner.java
new file mode 100644
index 0000000..9a833cf
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/common/util/URLCombiner.java
@@ -0,0 +1,16 @@
+package com.auth.userserver.common.util;
+
+import org.springframework.beans.factory.annotation.Value;
+import org.springframework.stereotype.Service;
+
+@Service
+public class URLCombiner {
+ @Value("${server.host}")
+ private String host;
+ @Value("${server.port}")
+ private String port;
+
+ public String combinePathWithHost(String path){
+ return "http://"+host+":"+port+path;
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/controller/SignUpController.java b/user-server/src/main/java/com/auth/userserver/controller/SignUpController.java
new file mode 100644
index 0000000..80e4b87
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/controller/SignUpController.java
@@ -0,0 +1,42 @@
+package com.auth.userserver.controller;
+
+import com.auth.userserver.dto.SignUpRequest;
+import com.auth.userserver.service.SignUpService;
+import lombok.RequiredArgsConstructor;
+import lombok.extern.slf4j.Slf4j;
+import org.springframework.http.HttpStatus;
+import org.springframework.http.ResponseEntity;
+import org.springframework.validation.Errors;
+import org.springframework.web.bind.annotation.*;
+
+import javax.validation.Valid;
+import java.util.Objects;
+import java.util.UUID;
+
+@Slf4j
+@RequiredArgsConstructor
+@RequestMapping("/api/signup")
+@RestController
+public class SignUpController {
+ private final SignUpService signUpService;
+
+ @PostMapping
+ ResponseEntity> signUp(@RequestBody @Valid SignUpRequest signUpRequest, Errors error){
+ if(error.hasErrors()) {
+ String errMsg = Objects.requireNonNull(error.getFieldError()).getDefaultMessage();
+ log.info(errMsg);
+ return ResponseEntity.status(HttpStatus.BAD_REQUEST).body(errMsg);
+ }
+ signUpService.signUp(signUpRequest);
+ return ResponseEntity.ok().build();
+ }
+
+ @GetMapping("/confirm")
+ ResponseEntity> verifyEmail(@RequestParam(required = true) UUID confirmToken){
+ boolean isVerified = signUpService.verfiyEmail(confirmToken);
+ if(!isVerified){
+ return ResponseEntity.status(HttpStatus.NOT_FOUND).build();
+ }
+ return ResponseEntity.ok().build();
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/controller/UserController.java b/user-server/src/main/java/com/auth/userserver/controller/UserController.java
new file mode 100644
index 0000000..dc53873
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/controller/UserController.java
@@ -0,0 +1,38 @@
+package com.auth.userserver.controller;
+
+import com.auth.userserver.dto.PageLimitRequest;
+import com.auth.userserver.dto.UserInfoResponse;
+import com.auth.userserver.model.Users;
+import com.auth.userserver.service.UserInfoService;
+import lombok.RequiredArgsConstructor;
+import lombok.extern.slf4j.Slf4j;
+import org.springframework.cache.annotation.Cacheable;
+import org.springframework.data.domain.Page;
+import org.springframework.http.HttpStatus;
+import org.springframework.http.ResponseEntity;
+import org.springframework.validation.Errors;
+import org.springframework.web.bind.annotation.*;
+
+import javax.validation.Valid;
+import java.util.Objects;
+
+@Slf4j
+@RequiredArgsConstructor
+@RequestMapping("/api/user")
+@RestController
+public class UserController {
+ private final UserInfoService userInfoService;
+
+ @GetMapping(produces = "application/json; charset=utf-8")
+ public ResponseEntity> getUsersInfo(@Valid PageLimitRequest pageLimitRequest, Errors error){
+ if(error.hasErrors()) {
+ String errMsg = Objects.requireNonNull(error.getFieldError()).getDefaultMessage();
+ log.info(errMsg);
+ return ResponseEntity.status(HttpStatus.BAD_REQUEST).body(errMsg);
+ }
+
+ Page userList = userInfoService.getUsersInfo(pageLimitRequest.of());
+ Page userInfoResponses = userList.map(UserInfoResponse::of);
+ return ResponseEntity.ok(userInfoResponses);
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/dto/PageLimitRequest.java b/user-server/src/main/java/com/auth/userserver/dto/PageLimitRequest.java
new file mode 100644
index 0000000..304e0c2
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/dto/PageLimitRequest.java
@@ -0,0 +1,28 @@
+package com.auth.userserver.dto;
+
+import lombok.Getter;
+import lombok.Setter;
+import org.springframework.data.domain.Sort;
+
+import javax.validation.constraints.Max;
+
+@Setter
+@Getter
+public class PageLimitRequest {
+ private int page;
+
+ @Max(value = 100, message = "요청할 수 있는 size의 최대크기는 100입니다.")
+ private int size;
+
+ private Sort.Direction sortDirection;
+
+ private String sortColumn;
+
+ public void setPage(int page) {
+ this.page = page <= 0 ? 1 : page;
+ }
+
+ public org.springframework.data.domain.PageRequest of() {
+ return org.springframework.data.domain.PageRequest.of(page -1, size, sortDirection, sortColumn);
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/dto/SignUpRequest.java b/user-server/src/main/java/com/auth/userserver/dto/SignUpRequest.java
new file mode 100644
index 0000000..cdeae39
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/dto/SignUpRequest.java
@@ -0,0 +1,29 @@
+package com.auth.userserver.dto;
+
+import lombok.AllArgsConstructor;
+import lombok.Getter;
+import lombok.RequiredArgsConstructor;
+import lombok.Setter;
+import org.hibernate.validator.constraints.Length;
+
+import javax.validation.constraints.Email;
+import javax.validation.constraints.NotBlank;
+import javax.validation.constraints.Pattern;
+
+@AllArgsConstructor
+@RequiredArgsConstructor
+@Setter @Getter
+public class SignUpRequest {
+ @NotBlank(message = "이름은 필수 입력 값입니다.")
+ @Length(min = 1, max = 30, message = "이름의 길이가 1부터 30 사이가 아닙니다.")
+ private String name;
+
+ @NotBlank(message = "이메일은 필수 입력 값입니다.")
+ @Email(message = "이메일 형식에 맞지 않습니다.")
+ private String email;
+
+ @NotBlank(message = "비밀번호은 필수 입력 값입니다.")
+ @Pattern(regexp="(?=.*[0-9])(?=.*[a-zA-Z])(?=.*\\W)(?=\\S+$).{8,20}",
+ message = "비밀번호는 영문 대,소문자와 숫자, 특수기호가 적어도 1개 이상씩 포함된 8자 ~ 20자의 비밀번호여야 합니다.")
+ private String password;
+}
diff --git a/user-server/src/main/java/com/auth/userserver/dto/UserInfoResponse.java b/user-server/src/main/java/com/auth/userserver/dto/UserInfoResponse.java
new file mode 100644
index 0000000..fa456e9
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/dto/UserInfoResponse.java
@@ -0,0 +1,33 @@
+package com.auth.userserver.dto;
+
+import com.auth.userserver.model.Users;
+import lombok.*;
+
+import java.time.LocalDateTime;
+import java.util.UUID;
+
+@AllArgsConstructor
+@RequiredArgsConstructor
+@Getter
+@Setter
+@Builder
+public class UserInfoResponse {
+ private UUID id;
+
+ private String name;
+
+ private String email;
+
+ private LocalDateTime createDt;
+
+ private LocalDateTime updateDt;
+
+ public static UserInfoResponse of(Users users){
+ return UserInfoResponse.builder()
+ .createDt(users.getCreateDt())
+ .name(users.getName())
+ .email(users.getEmail())
+ .updateDt(users.getUpdateDt())
+ .id(users.getId()).build();
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/model/EmailConfirmToken.java b/user-server/src/main/java/com/auth/userserver/model/EmailConfirmToken.java
new file mode 100644
index 0000000..f3485e3
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/model/EmailConfirmToken.java
@@ -0,0 +1,38 @@
+package com.auth.userserver.model;
+
+import jdk.jfr.Registered;
+import lombok.AllArgsConstructor;
+import lombok.Builder;
+import lombok.Getter;
+import lombok.RequiredArgsConstructor;
+import org.hibernate.annotations.CreationTimestamp;
+import org.hibernate.annotations.GenericGenerator;
+import org.hibernate.annotations.Type;
+
+import javax.persistence.*;
+import java.time.LocalDateTime;
+import java.util.UUID;
+
+@AllArgsConstructor
+@RequiredArgsConstructor
+@Getter
+@Builder
+@Entity
+public class EmailConfirmToken {
+ @Type(type="uuid-char")
+ @GeneratedValue(generator = "UUID")
+ @GenericGenerator(
+ name = "UUID",
+ strategy = "org.hibernate.id.UUIDGenerator"
+ )
+ @Id
+ private UUID id;
+
+ @CreationTimestamp
+ @Column(name = "create_dt", updatable = false)
+ private LocalDateTime createDt;
+
+ @OneToOne(targetEntity = Users.class, fetch = FetchType.EAGER)
+ @JoinColumn(name = "users_id", nullable = false)
+ private Users users;
+}
diff --git a/user-server/src/main/java/com/auth/userserver/model/Users.java b/user-server/src/main/java/com/auth/userserver/model/Users.java
new file mode 100644
index 0000000..ff976a4
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/model/Users.java
@@ -0,0 +1,75 @@
+package com.auth.userserver.model;
+
+import com.auth.userserver.dto.SignUpRequest;
+import lombok.*;
+import org.hibernate.annotations.CreationTimestamp;
+import org.hibernate.annotations.GenericGenerator;
+import org.hibernate.annotations.Type;
+import org.hibernate.annotations.UpdateTimestamp;
+
+import javax.persistence.*;
+import java.time.LocalDateTime;
+import java.util.UUID;
+
+@AllArgsConstructor
+@RequiredArgsConstructor
+@Getter
+@Setter
+@Builder
+@Entity
+public class Users {
+ @Type(type="uuid-char")
+ @GeneratedValue(generator = "UUID")
+ @GenericGenerator(
+ name = "UUID",
+ strategy = "org.hibernate.id.UUIDGenerator"
+ )
+ @Id
+ private UUID id;
+
+ @Column(name = "name",length = 30)
+ private String name;
+
+ @Column(unique = true)
+ private String email;
+
+ private String password;
+
+ @Column(name = "email_verified")
+ private boolean emailVerified;
+
+ @Column(name = "user_type", nullable = false)
+ private int userType;
+
+ @CreationTimestamp
+ @Column(name = "create_dt", updatable = false)
+ private LocalDateTime createDt;
+
+ @Setter
+ @UpdateTimestamp
+ @Column(name = "update_dt")
+ private LocalDateTime updateDt;
+
+ public static Users of(SignUpRequest signUpRequest){
+ return Users.builder()
+ .name(signUpRequest.getName())
+ .email(signUpRequest.getEmail())
+ .password(signUpRequest.getPassword())
+ .emailVerified(false)
+ .userType(1).build();
+ }
+
+ public static Users of(UUID id, SignUpRequest signUpRequest){
+ return Users.builder()
+ .id(id)
+ .name(signUpRequest.getName())
+ .email(signUpRequest.getEmail())
+ .password(signUpRequest.getPassword())
+ .emailVerified(false)
+ .userType(1).build();
+ }
+
+ public boolean isEmailVerified(){
+ return emailVerified;
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/repository/EmailConfirmTokenRepository.java b/user-server/src/main/java/com/auth/userserver/repository/EmailConfirmTokenRepository.java
new file mode 100644
index 0000000..583d88e
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/repository/EmailConfirmTokenRepository.java
@@ -0,0 +1,11 @@
+package com.auth.userserver.repository;
+
+import com.auth.userserver.model.EmailConfirmToken;
+import org.springframework.data.jpa.repository.JpaRepository;
+
+import java.util.Optional;
+import java.util.UUID;
+
+public interface EmailConfirmTokenRepository extends JpaRepository {
+ Optional findById(UUID id);
+}
diff --git a/user-server/src/main/java/com/auth/userserver/repository/UserRepository.java b/user-server/src/main/java/com/auth/userserver/repository/UserRepository.java
new file mode 100644
index 0000000..0f104d4
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/repository/UserRepository.java
@@ -0,0 +1,14 @@
+package com.auth.userserver.repository;
+
+import com.auth.userserver.model.Users;
+import org.springframework.data.domain.Page;
+import org.springframework.data.domain.Pageable;
+import org.springframework.data.jpa.repository.JpaRepository;
+
+import java.util.Optional;
+
+public interface UserRepository extends JpaRepository {
+ Page findAllByEmailVerifiedTrue(Pageable pageable);
+
+ Optional findByEmail(String email);
+}
diff --git a/user-server/src/main/java/com/auth/userserver/service/EmailService.java b/user-server/src/main/java/com/auth/userserver/service/EmailService.java
new file mode 100644
index 0000000..fcf6299
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/service/EmailService.java
@@ -0,0 +1,51 @@
+package com.auth.userserver.service;
+
+import com.auth.userserver.common.constants.ErrorEnum;
+import com.auth.userserver.common.exception.CustomException;
+import com.auth.userserver.common.util.URLCombiner;
+import com.auth.userserver.model.EmailConfirmToken;
+import com.auth.userserver.model.Users;
+import com.auth.userserver.repository.EmailConfirmTokenRepository;
+import com.auth.userserver.repository.UserRepository;
+import lombok.RequiredArgsConstructor;
+import org.springframework.beans.factory.annotation.Value;
+import org.springframework.mail.SimpleMailMessage;
+import org.springframework.mail.javamail.JavaMailSender;
+import org.springframework.stereotype.Service;
+import org.springframework.web.util.UriComponentsBuilder;
+
+import java.util.Optional;
+
+@RequiredArgsConstructor
+@Service
+public class EmailService {
+ private final JavaMailSender mailSender;
+ private final URLCombiner urlCombiner;
+ private final EmailConfirmTokenRepository emailConfirmTokenRepository;
+ private final UserRepository userRepository;
+ @Value("${spring.mail.username}")
+ private String senderEmail;
+
+ public void sendSignUpEmail(Users users) {
+ Optional savedUser = userRepository.findByEmail(users.getEmail());
+ if(savedUser.isEmpty())
+ throw new CustomException(ErrorEnum.USER_NOT_FOUND);
+ if(savedUser.get().isEmailVerified())
+ throw new CustomException(ErrorEnum.USER_ALREADY_CONFIRMED);
+
+ EmailConfirmToken emailConfirmToken = EmailConfirmToken.builder()
+ .users(users).build();
+ emailConfirmTokenRepository.save(emailConfirmToken);
+
+ String path = UriComponentsBuilder.fromPath("/api/signup/confirm")
+ .queryParam("confirmToken", emailConfirmToken.getId()).toUriString();
+
+ SimpleMailMessage message = new SimpleMailMessage();
+ message.setTo(emailConfirmToken.getUsers().getEmail());
+ message.setFrom(senderEmail);
+ message.setSubject("[소울메이츠] 회원 가입 인증 이메일");
+ message.setText("회원 인증 주소: " + urlCombiner.combinePathWithHost(path));
+
+ mailSender.send(message);
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/service/SignUpService.java b/user-server/src/main/java/com/auth/userserver/service/SignUpService.java
new file mode 100644
index 0000000..fde16b8
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/service/SignUpService.java
@@ -0,0 +1,56 @@
+package com.auth.userserver.service;
+
+import com.auth.userserver.common.constants.ErrorEnum;
+import com.auth.userserver.common.exception.CustomException;
+import com.auth.userserver.dto.SignUpRequest;
+import com.auth.userserver.model.EmailConfirmToken;
+import com.auth.userserver.model.Users;
+import com.auth.userserver.repository.EmailConfirmTokenRepository;
+import com.auth.userserver.repository.UserRepository;
+import lombok.RequiredArgsConstructor;
+import lombok.extern.slf4j.Slf4j;
+import org.springframework.security.crypto.password.Pbkdf2PasswordEncoder;
+import org.springframework.stereotype.Service;
+import org.springframework.transaction.annotation.Transactional;
+
+import java.util.Optional;
+import java.util.UUID;
+
+@Slf4j
+@RequiredArgsConstructor
+@Service
+public class SignUpService {
+ private final UserRepository userRepository;
+ private final EmailConfirmTokenRepository emailConfirmTokenRepository;
+ private final EmailService emailService;
+ private final Pbkdf2PasswordEncoder passwordEncoder;
+
+ @Transactional
+ public void signUp(SignUpRequest signUpRequest){
+ signUpRequest.setPassword(passwordEncoder.encode(signUpRequest.getPassword()));
+
+ Optional savedUser = userRepository.findByEmail(signUpRequest.getEmail());
+ if(savedUser.isPresent()){
+ if(savedUser.get().isEmailVerified())
+ throw new CustomException(ErrorEnum.USER_ALREADY_EXIST);
+ Users users = userRepository.save(Users.of(savedUser.get().getId(), signUpRequest));
+ emailService.sendSignUpEmail(users);
+ return;
+ }
+
+ Users users = userRepository.save(Users.of(signUpRequest));
+ emailService.sendSignUpEmail(users);
+ }
+
+ public boolean verfiyEmail(UUID confirmTokenId){
+ Optional confirmToken = emailConfirmTokenRepository.findById(confirmTokenId);
+ if(confirmToken.isEmpty()){
+ log.info("token is empty [{}]",confirmTokenId);
+ return false;
+ }
+ Users user = userRepository.findByEmail(confirmToken.get().getUsers().getEmail()).get();
+ user.setEmailVerified(true);
+ userRepository.save(user);
+ return true;
+ }
+}
diff --git a/user-server/src/main/java/com/auth/userserver/service/UserInfoService.java b/user-server/src/main/java/com/auth/userserver/service/UserInfoService.java
new file mode 100644
index 0000000..8b7c5c8
--- /dev/null
+++ b/user-server/src/main/java/com/auth/userserver/service/UserInfoService.java
@@ -0,0 +1,18 @@
+package com.auth.userserver.service;
+
+import com.auth.userserver.model.Users;
+import com.auth.userserver.repository.UserRepository;
+import lombok.RequiredArgsConstructor;
+import org.springframework.data.domain.Page;
+import org.springframework.data.domain.Pageable;
+import org.springframework.stereotype.Service;
+
+@RequiredArgsConstructor
+@Service
+public class UserInfoService {
+ private final UserRepository userRepository;
+
+ public Page getUsersInfo(Pageable pageable){
+ return userRepository.findAllByEmailVerifiedTrue(pageable);
+ }
+}
diff --git a/user-server/src/test/java/com/auth/userserver/UsersServerApplicationTests.java b/user-server/src/test/java/com/auth/userserver/UsersServerApplicationTests.java
new file mode 100644
index 0000000..7bd890e
--- /dev/null
+++ b/user-server/src/test/java/com/auth/userserver/UsersServerApplicationTests.java
@@ -0,0 +1,13 @@
+package com.auth.userserver;
+
+import org.junit.jupiter.api.Test;
+import org.springframework.boot.test.context.SpringBootTest;
+
+@SpringBootTest
+class UsersServerApplicationTests {
+
+ @Test
+ void contextLoads() {
+ }
+
+}